/*
 * ASE1603.asm
 *
 *  Created: 15/02/2016 11.05.58
 *  Author: Roberto Roncella
 *  Compito del 23/02/2016
 *  Realizzare una subroutine per il microcontrollore AVR XMEGA256A3BU, 
 *  il cui tempo di esecuzione in cicli di clock (escludendo l'istruzione di chiamata)
 *  sia esprimibile come a+bN, ove N e` il valore contenuto in R16 e a, b sono costanti 
 *  di cui e` richiesto di specificare il valore. Indicare inoltre il massimo ritardo ottenibile.
 *
 *  A posteriori si osserva che il tempo di esecuzione della subroutine proposta
 *  e` pari a (10+3N)Tclock. Il massimo di ha per R16=0, che viene interpretato come N=256 
 *  e da` un ritardo di 778 Tclock.
 */ 
test: //sezione di test della subroutine
 ldi R16,0
 rcall R_delay
 ldi R16,1
 rcall R_delay
 ldi R16,100
 rcall R_delay
 ldi R16,101
 rcall R_delay
 ldi R16,255
 rcall R_delay
 rjmp test

R_delay:
 push R16 //salva i registri usati
loop:
 dec R16
 brne loop
 pop R16
 ret 
